<template>
    <p class="whitespace pre-wrap">
        <component :is="body" />
    </p>
</template>
<script>
export default {
    props: {
        post: {
            required: true,
            type: Object
        }
    },

    computed: {
        body() {
            return {
                'template': `<div>${ this.replaceEntities(this.post.body) } </div>`
            }
        },

        entities() {
            // sort the entities within the post in reverse order
            return this.post.entities.data.sort((a, b) => b.start - a.start);
        }
    },

    methods: {
        // foreach entity in the body
        // go from the start of the body to the start of the first entity
        // take the string from the start of the body to the start of the entity and concatenate the entity
        // next take the rest of the body and concatenate it from the end of the entity
        replaceEntities(body) {
            this.entities.forEach((entity) => {
                body = body.substring(0, entity.start) + this.entityComponent(entity) + body.substring(entity.end);
            });

            return body;
        },

        entityComponent(entity) {
            return `<app-${ entity.type }-entity body="${entity.body}" body_plain="${entity.body_plain}"/>`;
        }
    },
}
</script>
